#ifndef __XED_WRAPPER_H
#define __XED_WRAPPER_H

#include "Windas.h"

extern "C"
{
#include <xed/xed-interface.h>
}


VOID InitXed();

#define XED_DECODED_INST xed_decoded_inst_t
#define XED_INST xed_inst_t
#define XED_OPERAND xed_operand_t

#define XED_OPERAND_TYPE_ENUM xed_operand_type_enum_t
#define XED_ERROR_ENUM xed_error_enum_t
#define XED_CATEGORY_ENUM xed_category_enum_t

#define XedDecodedInstZero xed_decoded_inst_zero
#define XedDecodedInstSetMode xed_decoded_inst_set_mode
#define XedDecode xed_decode
#define XedDecodedInstGetLength xed_decoded_inst_get_length
#define XedDecodedInstGetCategory xed_decoded_inst_get_category
#define XedDecodedInstGetBranchDisplacementWidth xed_decoded_inst_get_branch_displacement_width
#define XedDecodedInstGetBranchDisplacement xed_decoded_inst_get_branch_displacement
#define XedDecodedInstInst xed_decoded_inst_inst
#define XedDecodedInstNumOperands xed_decoded_inst_noperands

#define XedInstOperand xed_inst_operand

#define XedOperandType xed_operand_type

#define XedErrorEnumToString xed_error_enum_t2str
#define XedCategoryEnumToString xed_category_enum_t2str

#endif